<?php

namespace fk_\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OdemePlani StructType
 * @subpackage Structs
 */
class OdemePlani extends SerendipEntity
{
    /**
     * The ErkenOdemeFaizi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $ErkenOdemeFaizi;
    /**
     * The GecOdemeFaizi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $GecOdemeFaizi;
    /**
     * The GunPazartesi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $GunPazartesi;
    /**
     * The GunSali
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $GunSali;
    /**
     * The GunCarsamba
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $GunCarsamba;
    /**
     * The GunPersembe
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $GunPersembe;
    /**
     * The GunCuma
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $GunCuma;
    /**
     * The GunCumartesi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $GunCumartesi;
    /**
     * The GunPazar
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $GunPazar;
    /**
     * The GunResmiTatil
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $GunResmiTatil;
    /**
     * The SadecePosIcin
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $SadecePosIcin;
    /**
     * The SatisIcinKullanilsin
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $SatisIcinKullanilsin;
    /**
     * The SatinalmaIcinKullanilsin
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $SatinalmaIcinKullanilsin;
    /**
     * The Kodu
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Kodu;
    /**
     * The Adi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Adi;
    /**
     * The Aciklama
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Aciklama;
    /**
     * The FormulSatirlari
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \fk_\ArrayType\ArrayOfOdemePlaniSatiri
     */
    public $FormulSatirlari;
    /**
     * Constructor method for OdemePlani
     * @uses OdemePlani::setErkenOdemeFaizi()
     * @uses OdemePlani::setGecOdemeFaizi()
     * @uses OdemePlani::setGunPazartesi()
     * @uses OdemePlani::setGunSali()
     * @uses OdemePlani::setGunCarsamba()
     * @uses OdemePlani::setGunPersembe()
     * @uses OdemePlani::setGunCuma()
     * @uses OdemePlani::setGunCumartesi()
     * @uses OdemePlani::setGunPazar()
     * @uses OdemePlani::setGunResmiTatil()
     * @uses OdemePlani::setSadecePosIcin()
     * @uses OdemePlani::setSatisIcinKullanilsin()
     * @uses OdemePlani::setSatinalmaIcinKullanilsin()
     * @uses OdemePlani::setKodu()
     * @uses OdemePlani::setAdi()
     * @uses OdemePlani::setAciklama()
     * @uses OdemePlani::setFormulSatirlari()
     * @param float $erkenOdemeFaizi
     * @param float $gecOdemeFaizi
     * @param bool $gunPazartesi
     * @param bool $gunSali
     * @param bool $gunCarsamba
     * @param bool $gunPersembe
     * @param bool $gunCuma
     * @param bool $gunCumartesi
     * @param bool $gunPazar
     * @param bool $gunResmiTatil
     * @param bool $sadecePosIcin
     * @param bool $satisIcinKullanilsin
     * @param bool $satinalmaIcinKullanilsin
     * @param string $kodu
     * @param string $adi
     * @param string $aciklama
     * @param \fk_\ArrayType\ArrayOfOdemePlaniSatiri $formulSatirlari
     */
    public function __construct($erkenOdemeFaizi = null, $gecOdemeFaizi = null, $gunPazartesi = null, $gunSali = null, $gunCarsamba = null, $gunPersembe = null, $gunCuma = null, $gunCumartesi = null, $gunPazar = null, $gunResmiTatil = null, $sadecePosIcin = null, $satisIcinKullanilsin = null, $satinalmaIcinKullanilsin = null, $kodu = null, $adi = null, $aciklama = null, \fk_\ArrayType\ArrayOfOdemePlaniSatiri $formulSatirlari = null)
    {
        $this
            ->setErkenOdemeFaizi($erkenOdemeFaizi)
            ->setGecOdemeFaizi($gecOdemeFaizi)
            ->setGunPazartesi($gunPazartesi)
            ->setGunSali($gunSali)
            ->setGunCarsamba($gunCarsamba)
            ->setGunPersembe($gunPersembe)
            ->setGunCuma($gunCuma)
            ->setGunCumartesi($gunCumartesi)
            ->setGunPazar($gunPazar)
            ->setGunResmiTatil($gunResmiTatil)
            ->setSadecePosIcin($sadecePosIcin)
            ->setSatisIcinKullanilsin($satisIcinKullanilsin)
            ->setSatinalmaIcinKullanilsin($satinalmaIcinKullanilsin)
            ->setKodu($kodu)
            ->setAdi($adi)
            ->setAciklama($aciklama)
            ->setFormulSatirlari($formulSatirlari);
    }
    /**
     * Get ErkenOdemeFaizi value
     * @return float
     */
    public function getErkenOdemeFaizi()
    {
        return $this->ErkenOdemeFaizi;
    }
    /**
     * Set ErkenOdemeFaizi value
     * @param float $erkenOdemeFaizi
     * @return \fk_\StructType\OdemePlani
     */
    public function setErkenOdemeFaizi($erkenOdemeFaizi = null)
    {
        // validation for constraint: float
        if (!is_null($erkenOdemeFaizi) && !(is_float($erkenOdemeFaizi) || is_numeric($erkenOdemeFaizi))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($erkenOdemeFaizi, true), gettype($erkenOdemeFaizi)), __LINE__);
        }
        $this->ErkenOdemeFaizi = $erkenOdemeFaizi;
        return $this;
    }
    /**
     * Get GecOdemeFaizi value
     * @return float
     */
    public function getGecOdemeFaizi()
    {
        return $this->GecOdemeFaizi;
    }
    /**
     * Set GecOdemeFaizi value
     * @param float $gecOdemeFaizi
     * @return \fk_\StructType\OdemePlani
     */
    public function setGecOdemeFaizi($gecOdemeFaizi = null)
    {
        // validation for constraint: float
        if (!is_null($gecOdemeFaizi) && !(is_float($gecOdemeFaizi) || is_numeric($gecOdemeFaizi))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($gecOdemeFaizi, true), gettype($gecOdemeFaizi)), __LINE__);
        }
        $this->GecOdemeFaizi = $gecOdemeFaizi;
        return $this;
    }
    /**
     * Get GunPazartesi value
     * @return bool
     */
    public function getGunPazartesi()
    {
        return $this->GunPazartesi;
    }
    /**
     * Set GunPazartesi value
     * @param bool $gunPazartesi
     * @return \fk_\StructType\OdemePlani
     */
    public function setGunPazartesi($gunPazartesi = null)
    {
        // validation for constraint: boolean
        if (!is_null($gunPazartesi) && !is_bool($gunPazartesi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($gunPazartesi, true), gettype($gunPazartesi)), __LINE__);
        }
        $this->GunPazartesi = $gunPazartesi;
        return $this;
    }
    /**
     * Get GunSali value
     * @return bool
     */
    public function getGunSali()
    {
        return $this->GunSali;
    }
    /**
     * Set GunSali value
     * @param bool $gunSali
     * @return \fk_\StructType\OdemePlani
     */
    public function setGunSali($gunSali = null)
    {
        // validation for constraint: boolean
        if (!is_null($gunSali) && !is_bool($gunSali)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($gunSali, true), gettype($gunSali)), __LINE__);
        }
        $this->GunSali = $gunSali;
        return $this;
    }
    /**
     * Get GunCarsamba value
     * @return bool
     */
    public function getGunCarsamba()
    {
        return $this->GunCarsamba;
    }
    /**
     * Set GunCarsamba value
     * @param bool $gunCarsamba
     * @return \fk_\StructType\OdemePlani
     */
    public function setGunCarsamba($gunCarsamba = null)
    {
        // validation for constraint: boolean
        if (!is_null($gunCarsamba) && !is_bool($gunCarsamba)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($gunCarsamba, true), gettype($gunCarsamba)), __LINE__);
        }
        $this->GunCarsamba = $gunCarsamba;
        return $this;
    }
    /**
     * Get GunPersembe value
     * @return bool
     */
    public function getGunPersembe()
    {
        return $this->GunPersembe;
    }
    /**
     * Set GunPersembe value
     * @param bool $gunPersembe
     * @return \fk_\StructType\OdemePlani
     */
    public function setGunPersembe($gunPersembe = null)
    {
        // validation for constraint: boolean
        if (!is_null($gunPersembe) && !is_bool($gunPersembe)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($gunPersembe, true), gettype($gunPersembe)), __LINE__);
        }
        $this->GunPersembe = $gunPersembe;
        return $this;
    }
    /**
     * Get GunCuma value
     * @return bool
     */
    public function getGunCuma()
    {
        return $this->GunCuma;
    }
    /**
     * Set GunCuma value
     * @param bool $gunCuma
     * @return \fk_\StructType\OdemePlani
     */
    public function setGunCuma($gunCuma = null)
    {
        // validation for constraint: boolean
        if (!is_null($gunCuma) && !is_bool($gunCuma)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($gunCuma, true), gettype($gunCuma)), __LINE__);
        }
        $this->GunCuma = $gunCuma;
        return $this;
    }
    /**
     * Get GunCumartesi value
     * @return bool
     */
    public function getGunCumartesi()
    {
        return $this->GunCumartesi;
    }
    /**
     * Set GunCumartesi value
     * @param bool $gunCumartesi
     * @return \fk_\StructType\OdemePlani
     */
    public function setGunCumartesi($gunCumartesi = null)
    {
        // validation for constraint: boolean
        if (!is_null($gunCumartesi) && !is_bool($gunCumartesi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($gunCumartesi, true), gettype($gunCumartesi)), __LINE__);
        }
        $this->GunCumartesi = $gunCumartesi;
        return $this;
    }
    /**
     * Get GunPazar value
     * @return bool
     */
    public function getGunPazar()
    {
        return $this->GunPazar;
    }
    /**
     * Set GunPazar value
     * @param bool $gunPazar
     * @return \fk_\StructType\OdemePlani
     */
    public function setGunPazar($gunPazar = null)
    {
        // validation for constraint: boolean
        if (!is_null($gunPazar) && !is_bool($gunPazar)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($gunPazar, true), gettype($gunPazar)), __LINE__);
        }
        $this->GunPazar = $gunPazar;
        return $this;
    }
    /**
     * Get GunResmiTatil value
     * @return bool
     */
    public function getGunResmiTatil()
    {
        return $this->GunResmiTatil;
    }
    /**
     * Set GunResmiTatil value
     * @param bool $gunResmiTatil
     * @return \fk_\StructType\OdemePlani
     */
    public function setGunResmiTatil($gunResmiTatil = null)
    {
        // validation for constraint: boolean
        if (!is_null($gunResmiTatil) && !is_bool($gunResmiTatil)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($gunResmiTatil, true), gettype($gunResmiTatil)), __LINE__);
        }
        $this->GunResmiTatil = $gunResmiTatil;
        return $this;
    }
    /**
     * Get SadecePosIcin value
     * @return bool
     */
    public function getSadecePosIcin()
    {
        return $this->SadecePosIcin;
    }
    /**
     * Set SadecePosIcin value
     * @param bool $sadecePosIcin
     * @return \fk_\StructType\OdemePlani
     */
    public function setSadecePosIcin($sadecePosIcin = null)
    {
        // validation for constraint: boolean
        if (!is_null($sadecePosIcin) && !is_bool($sadecePosIcin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sadecePosIcin, true), gettype($sadecePosIcin)), __LINE__);
        }
        $this->SadecePosIcin = $sadecePosIcin;
        return $this;
    }
    /**
     * Get SatisIcinKullanilsin value
     * @return bool
     */
    public function getSatisIcinKullanilsin()
    {
        return $this->SatisIcinKullanilsin;
    }
    /**
     * Set SatisIcinKullanilsin value
     * @param bool $satisIcinKullanilsin
     * @return \fk_\StructType\OdemePlani
     */
    public function setSatisIcinKullanilsin($satisIcinKullanilsin = null)
    {
        // validation for constraint: boolean
        if (!is_null($satisIcinKullanilsin) && !is_bool($satisIcinKullanilsin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($satisIcinKullanilsin, true), gettype($satisIcinKullanilsin)), __LINE__);
        }
        $this->SatisIcinKullanilsin = $satisIcinKullanilsin;
        return $this;
    }
    /**
     * Get SatinalmaIcinKullanilsin value
     * @return bool
     */
    public function getSatinalmaIcinKullanilsin()
    {
        return $this->SatinalmaIcinKullanilsin;
    }
    /**
     * Set SatinalmaIcinKullanilsin value
     * @param bool $satinalmaIcinKullanilsin
     * @return \fk_\StructType\OdemePlani
     */
    public function setSatinalmaIcinKullanilsin($satinalmaIcinKullanilsin = null)
    {
        // validation for constraint: boolean
        if (!is_null($satinalmaIcinKullanilsin) && !is_bool($satinalmaIcinKullanilsin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($satinalmaIcinKullanilsin, true), gettype($satinalmaIcinKullanilsin)), __LINE__);
        }
        $this->SatinalmaIcinKullanilsin = $satinalmaIcinKullanilsin;
        return $this;
    }
    /**
     * Get Kodu value
     * @return string|null
     */
    public function getKodu()
    {
        return $this->Kodu;
    }
    /**
     * Set Kodu value
     * @param string $kodu
     * @return \fk_\StructType\OdemePlani
     */
    public function setKodu($kodu = null)
    {
        // validation for constraint: string
        if (!is_null($kodu) && !is_string($kodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kodu, true), gettype($kodu)), __LINE__);
        }
        $this->Kodu = $kodu;
        return $this;
    }
    /**
     * Get Adi value
     * @return string|null
     */
    public function getAdi()
    {
        return $this->Adi;
    }
    /**
     * Set Adi value
     * @param string $adi
     * @return \fk_\StructType\OdemePlani
     */
    public function setAdi($adi = null)
    {
        // validation for constraint: string
        if (!is_null($adi) && !is_string($adi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($adi, true), gettype($adi)), __LINE__);
        }
        $this->Adi = $adi;
        return $this;
    }
    /**
     * Get Aciklama value
     * @return string|null
     */
    public function getAciklama()
    {
        return $this->Aciklama;
    }
    /**
     * Set Aciklama value
     * @param string $aciklama
     * @return \fk_\StructType\OdemePlani
     */
    public function setAciklama($aciklama = null)
    {
        // validation for constraint: string
        if (!is_null($aciklama) && !is_string($aciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aciklama, true), gettype($aciklama)), __LINE__);
        }
        $this->Aciklama = $aciklama;
        return $this;
    }
    /**
     * Get FormulSatirlari value
     * @return \fk_\ArrayType\ArrayOfOdemePlaniSatiri|null
     */
    public function getFormulSatirlari()
    {
        return $this->FormulSatirlari;
    }
    /**
     * Set FormulSatirlari value
     * @param \fk_\ArrayType\ArrayOfOdemePlaniSatiri $formulSatirlari
     * @return \fk_\StructType\OdemePlani
     */
    public function setFormulSatirlari(\fk_\ArrayType\ArrayOfOdemePlaniSatiri $formulSatirlari = null)
    {
        $this->FormulSatirlari = $formulSatirlari;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\StructType\OdemePlani
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
